# -*- coding: utf-8 -*-

"""
shellcardmanagementapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellcardmanagementapis.api_helper import APIHelper
from shellcardmanagementapis.models.pin_reminder_reference import PINReminderReference


class PINReminderResponse(object):

    """Implementation of the 'PINReminderResponse' model.

    Attributes:
        request_id (str): Unique request identifier passed from end user. This
            identifier helps in tracing a transaction
        main_reference (int): Service reference number for tracking.
        status (str): Indicates overall status of the request. Allowed values:
            SUCCESS, FAILED
        data (List[PINReminderReference]): The model property of type
            List[PINReminderReference].

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "request_id": 'RequestId',
        "main_reference": 'MainReference',
        "status": 'Status',
        "data": 'Data'
    }

    _optionals = [
        'request_id',
        'main_reference',
        'status',
        'data',
    ]

    def __init__(self,
                 request_id=APIHelper.SKIP,
                 main_reference=APIHelper.SKIP,
                 status=APIHelper.SKIP,
                 data=APIHelper.SKIP):
        """Constructor for the PINReminderResponse class"""

        # Initialize members of the class
        if request_id is not APIHelper.SKIP:
            self.request_id = request_id 
        if main_reference is not APIHelper.SKIP:
            self.main_reference = main_reference 
        if status is not APIHelper.SKIP:
            self.status = status 
        if data is not APIHelper.SKIP:
            self.data = data 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        request_id = dictionary.get("RequestId") if dictionary.get("RequestId") else APIHelper.SKIP
        main_reference = dictionary.get("MainReference") if dictionary.get("MainReference") else APIHelper.SKIP
        status = dictionary.get("Status") if dictionary.get("Status") else APIHelper.SKIP
        data = None
        if dictionary.get('Data') is not None:
            data = [PINReminderReference.from_dictionary(x) for x in dictionary.get('Data')]
        else:
            data = APIHelper.SKIP
        # Return an object of this model
        return cls(request_id,
                   main_reference,
                   status,
                   data)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'request_id={(self.request_id if hasattr(self, "request_id") else None)!r}, '
                f'main_reference={(self.main_reference if hasattr(self, "main_reference") else None)!r}, '
                f'status={(self.status if hasattr(self, "status") else None)!r}, '
                f'data={(self.data if hasattr(self, "data") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'request_id={(self.request_id if hasattr(self, "request_id") else None)!s}, '
                f'main_reference={(self.main_reference if hasattr(self, "main_reference") else None)!s}, '
                f'status={(self.status if hasattr(self, "status") else None)!s}, '
                f'data={(self.data if hasattr(self, "data") else None)!s})')
